//
// Original Keith Oyama (keisrtp@gmail.com)
// Changed by yoshinori.H 2011/02/06
//

var gDragged;
var gDeltaX, gDeltaY;
var gOrgX, gOrgY;
var gOrgHeight;
var gDraggedId;
var gDropTId
var isMove;
var isResize;

var baseTop = 60;
var topsnap = 10;
var baseLeft = 10;
var leftsnap = 150;

///////////////////////////////////////////////////////////////////////////////


function addEvent( elm, evtType, fn, useCapture) {
	if (elm.addEventListener) {
		elm.addEventListener(evtType, fn, useCapture);
		return true;
	} else if (elm.attachEvent) {
		var r = elm.attachEvent('on' + evtType, fn);
		return r;
	}	else {
		elm['on'+evtType] = fn;
	}
}

///////////////////////////////////////////////////////////////////////////////
function removeEvent( elm, evtType, fn, useCapture) {
    if (elm.removeEventListener) {
        elm.removeEventListener(evtType, fn, useCapture);
        return true;
    } else if (elm.detachEvent) {
        var r = elm.detachEvent('on' + evtType, fn);
        return r;
    } else {
        elm['on'+evtType] = fn;
    }
}

///////////////////////////////////////////////////////////////////////////////
function setCursor ( elm, curtype ) {
    elm.style.cursor = curtype;
}

///////////////////////////////////////////////////////////////////////////////
function setOpacity(node,val) {
    if (node.filters) {
        try {
            node.filters["alpha"].opacity = val*70;
        } catch (e) { }
    } else if (node.style.opacity) {
        node.style.opacity = val;
    }
}

///////////////////////////////////////////////////////////////////////////////
function getAttrValue ( elm, attrname ) {
    return elm.attributes[ attrname ].nodeValue;
}

///////////////////////////////////////////////////////////////////////////////
function getX ( elm ) {
    return parseInt(elm.style.left);
}

///////////////////////////////////////////////////////////////////////////////
function getY ( elm ) {
    return parseInt(elm.style.top);
}

///////////////////////////////////////////////////////////////////////////////
function getEventX ( evt ) {
    return evt.pageX ? evt.pageX : evt.clientX;
}

///////////////////////////////////////////////////////////////////////////////
function getEventY ( evt ) {
    return evt.pageY ? evt.pageY : evt.clientY;
}

///////////////////////////////////////////////////////////////////////////////
function getWidth ( elm ) {
    return parseInt( elm.style.width );
}

///////////////////////////////////////////////////////////////////////////////
function getHeight ( elm ) {
    return parseInt( elm.style.height );
}

///////////////////////////////////////////////////////////////////////////////
function moveElm ( elm, x, y ) {
    elm.style.left = x + 'px';
    elm.style.top = y + 'px';
}

///////////////////////////////////////////////////////////////////////////////
function onMouseDown (evt) {

    var target = evt.target ? evt.target : evt.srcElement;
    var x = getEventX ( evt );
    var y = getEventY ( evt );
    //
    // Save Information to Globals
    //
    gDragged = target;
	var ty = getY(gDragged);
    gDeltaX = x - getX(gDragged);
    gDeltaY = y - ty;

	isResize = false;
    gDraggedId = getAttrValue ( gDragged, 'did' );
	if ((ty + getHeight(gDragged) - y) < 5) {
        setCursor ( gDragged, 's-resize' );
		isResize = true;
	}

    gOrgX = getX ( gDragged );
    gOrgY = getY ( gDragged );
	gOrgHeight = getHeight( gDragged );

    setOpacity ( gDragged, 0.5 );

    addEvent ( document, 'mousemove', onMouseMove, false );
    addEvent ( document, 'mouseup', onMouseUp, false );
	isMove = false;
}

///////////////////////////////////////////////////////////////////////////////
function onMouseMove(evt) {
    var x = getEventX ( evt );
    var y = getEventY ( evt );
	var nx = (Math.round((x - gDeltaX - baseLeft) / leftsnap) * leftsnap) + baseLeft;
	var ny = (Math.round((y - gDeltaY - baseTop) / topsnap) * topsnap) + baseTop;
	if (isResize) {
		gDragged.style.height = gOrgHeight + ny - gOrgY;
	} else {
      moveElm ( gDragged, nx, ny );
	}
	isMove = true;
}

///////////////////////////////////////////////////////////////////////////////
function onMouseUp(evt) {
    setOpacity( gDragged, 1);
    removeEvent ( document, 'mousemove', onMouseMove, false );
    removeEvent ( document, 'mouseup', onMouseUp, false );

	if (isResize) {
        setCursor ( gDragged, 'move' );
	}

	if (isMove) {
      if ( isOnDropTarget (evt) ) {
        onDropped(evt);
      } else {
        moveElm ( gDragged, gOrgX, gOrgY );
      }
	} else {
		onClick(evt);
	}
}

///////////////////////////////////////////////////////////////////////////////
function isOnDropTarget (evt) {
    var all_divs = document.getElementsByTagName('div');

    for ( var i=0; i<all_divs.length; i++ ) {
        if ( all_divs[i].attributes['tid'] ) {
            if ( isEventOnElm ( evt, all_divs[i].id ) ) {
                gDropTId = getAttrValue ( all_divs[i], 'tid' );
                return true;
            }
        }
     }
    return false;
}

///////////////////////////////////////////////////////////////////////////////
function isEventOnElm (evt, drop_target_id) {
    var evtX = getEventX(evt);
    var evtY = getEventY(evt);
    var drop_target = document.getElementById( drop_target_id );
    var x = getX ( drop_target );
    var y = getY ( drop_target );
    var width = getWidth ( drop_target );
    var height = getHeight ( drop_target );

    return evtX > x && evtY > y && evtX < x + width && evtY < y + height;
}

///////////////////////////////////////////////////////////////////////////////
function onDropped (evt) {
	var ntime = getY(gDragged) - baseTop;
	var ninterval = getHeight(gDragged);
    // alert('Dropped! target: [' + gDropTId + '] Dropped did: [' + gDraggedId + '] top:[' + ntime + '] height:[' + ninterval + ']');
	var url =  document.getElementsByName("urlval").item(0).value;
	url += "&action=ddmod";
	url += "&uid=";
	url += mainForm.item("uid").value;
	url += "&seq=";
	url += gDraggedId;
	url += "&day=";
	url += gDropTId;
	url += "&top=";
	url += ntime;
	url += "&height=";
	url += ninterval;
	url += "&pno=";
	url += gDragged.id;

    var ajaxUtil = new AjaxUtil();
	ajaxUtil.post(url, "", document.getElementById("tempArea"), false);
	// ajaxUtil.get(url, document.getElementById("tempArea"));
}

///////////////////////////////////////////////////////////////////////////////
function onClick (evt) {
    // alert('Click! id: [' + evt.srcElement.id + '] did: [' + evt.srcElement.getAttribute('did') + ']');
    mod(evt.srcElement.getAttribute('did'));
}

///////////////////////////////////////////////////////////////////////////////
function init () {
    document.body.ondrag = function () { return false; };
    document.body.onselectstart = function () { return false; };
    //
    // Assign Event Handlers
    //
    var all_elms = document.getElementsByTagName ( 'div' );

    for ( var i = 0; i < all_elms.length; i++ ) {
        if ( getAttrValue ( all_elms[i], 'class' ) == 'dragged_elm' ) {
            addEvent ( all_elms[i], 'mousedown', onMouseDown, false );
        }
    }
}

addEvent ( window, 'load', init, false );
